const fs = require('fs');
const path = require('path');
const schemas = require('axway-schema');
const axwayFlowSchema = require('axway-flow-schema');
const FlowManager = require('./flowmanager');

// register all axway-flow-schema
schemas.register(axwayFlowSchema.all).loadSync();

function register(flowManager) {
	fs.readdirSync(path.join(__dirname, 'nodehandlers'))
		.forEach(fname => {
			// strip the name from the .js file and use it as part of a require path.
			const type = fname.replace(/\.js$/, '');
			const uri = FlowManager.formatNodeHandlerUri('axway-flow', type);
			// eslint-disable-next-line security/detect-non-literal-require
			const handlerModule = require(path.join(__dirname, 'nodehandlers', type));
			flowManager.registerNode(uri, handlerModule.handler, handlerModule.spec);
		});
}

function unregister(flowManager) {
	fs.readdirSync(path.join(__dirname, 'nodehandlers'))
		.forEach(fname => {
			// strip the name from the .js file and use it as part of a require path.
			const type = fname.replace(/\.js$/, '');
			const uri = FlowManager.formatNodeHandlerUri('axway-flow', type);
			flowManager.unregisterNode(uri);
		});
}

exports = module.exports = {
	FlowManager,
	FlowNode: require('./flownode'),
	register,
	unregister
};
