const jsonpath = require('@livereach/jsonpath');

/**
 * Get a value by JSONPath.
 * @param {object} key - The jsonpath being queried.
 * @param {object} obj - The object being searched.
 * @return {object} The first result of the query.
 */
const getByJsonPath = (key, obj) => {
	let val;

	if (!(obj instanceof Object)) {
		if (key === '$') {
			val = obj;
		}
	} else {
		val = jsonpath.query(obj, key);
		val = val.length > 0 ? val[0] : undefined;
	}

	return val;
};

exports = module.exports = {
	getByJsonPath
};
