const FlowManager = require('../flowmanager');

module.exports = {
	id: 'main1to2',
	stage: 'main',
	type: 'flow',
	from: '1',
	to: '2',
	owner: 'API Builder',
	fn: (flow) => {
		return new Promise((resolve) => {
			for (const id of Object.keys(flow.nodes)) {
				const node = flow.nodes[id];
				// upgrade the node type to use a URI in version 2
				if (node.type === 'parametermap' || node.type === 'delay' || node.type === 'switch') {
					node.type = FlowManager.formatNodeHandlerUri('axway-flow', node.type);
				}
				// nodes now have names.  if no name assigned, set it as the id
				if (!node.name) {
					node.name = id;
				}
			}
			return resolve(flow);
		});
	}
};
