module.exports = {
	id: 'main2to3',
	stage: 'main',
	type: 'flow',
	from: '2',
	to: '3',
	owner: 'API Builder',
	fn: (flow) => {
		const info = {
			name: flow.name
		};
		const parameter = {
			properties: {
				params: {
					type: 'object',
					description: 'The parameters from the endpoint.'
				},
				request: {
					type: 'object',
					description: 'The HTTP request.'
				},
				config: {
					type: 'object',
					description: 'The service\'s configuration'
				},
				env: {
					type: 'object',
					description: 'The host OS environment'
				}
			},
			additionalProperties: false,
			required: [
				'params',
				'request',
				'config',
				'env'
			]
		};

		// preserve specific order of keys
		return Promise.resolve({
			schemaVersion: flow.schemaVersion,
			info,
			parameter,
			start: flow.start,
			nodes: flow.nodes
		});
	}
};
